package de.jatitv.opsecurity.system;

import de.jatitv.opsecurity.cmdManagement.CmdExecuter;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.listener.Events;
import de.jatitv.opsecurity.listener.OPCommand;
import de.jatitv.opsecurity.listener.PlugManCommand;
import de.jatitv.opsecurity.objects.PlayerObject;
import de.jatitv.opsecurity.util.Metrics;
import de.jatitv.opsecurity.util.UpdateChecker;
import de.jatitv.opsecurity.util.send;
import org.bukkit.Bukkit;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.logging.Logger;

public final class Main extends JavaPlugin {


    // Debug Settings

    public static Boolean Bstats = true;

    public static String Prefix = "§8[§2OP§4Security§8]";

    public static List<String> Autor;
    public static Integer SpigotID = 90739;
    public static Integer BstatsID = 10858;
    public static String Spigot = "https://spigotmc.org/resources/" + SpigotID;
    public static String Discord = "http://dc.t2code.net";


    // ---------------------------------------------

    public static String Version;

    public static Main plugin;
    public static String update_version = null;

    public static boolean minecraft1_8;
    public static boolean minecraft1_9;
    public static boolean minecraft1_10;
    public static boolean minecraft1_11;
    public static boolean minecraft1_12;

    public static File getPath() {
        return plugin.getDataFolder();
    }

    public static HashMap<String, PlayerObject> opHashMap = new HashMap<String, PlayerObject>();
    public static HashMap<String, PlayerObject> permissionHashMap = new HashMap<String, PlayerObject>();


    @Override
    public void onEnable() {
        // Plugin startup logic
        Logger logger = this.getLogger();
        plugin = this;

        Autor = plugin.getDescription().getAuthors();
        Version = plugin.getDescription().getVersion();

        minecraft1_8 = Bukkit.getServer().getClass().getPackage().getName().contains("1_8");
        minecraft1_9 = Bukkit.getServer().getClass().getPackage().getName().contains("1_9");
        minecraft1_10 = Bukkit.getServer().getClass().getPackage().getName().contains("1_10");
        minecraft1_11 = Bukkit.getServer().getClass().getPackage().getName().contains("1_11");
        minecraft1_12 = Bukkit.getServer().getClass().getPackage().getName().contains("1_12");

        Load.onLoad(Prefix, Autor, Version, Spigot, Discord);

        getCommand("opsecurity").setExecutor(new CmdExecuter());

        Bukkit.getServer().getPluginManager().registerEvents(new Events(), this);
        Bukkit.getServer().getPluginManager().registerEvents(new OPCommand(), this);
        Bukkit.getServer().getPluginManager().registerEvents(new PlugManCommand(), this);
        // Bukkit.getServer().getPluginManager().registerEvents(new LPCommand(), this);


        if (Main.Bstats) {
            int pluginId = BstatsID; // <-- Replace with the id of your plugin!
            Metrics metrics = new Metrics(this, pluginId);
            metrics.addCustomChart(new Metrics.SimplePie("updatecheckonjoin", () -> String.valueOf(SelectConfig.UpdateCheckOnJoin)));
        } else {
            new BukkitRunnable() {
                @Override
                public void run() {
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§4\n" + Main.Prefix + "§4Bstats is disabled!");
                }
            }.runTaskLater(Main.plugin, 200L);
        }


        UpdateChecker.onUpdateCheck();
        UpdateChecker.onUpdateCheckTimer();
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }
}
